//========================================================
//        File: keys.h
//
// Description: Contains the array of key descriptions and
//              a function to translate between numbers
//              and the matching key.
//
//          By: Kurt Hoffmann
//        Date: 3/3/2002
//     Version: 1.0
//========================================================


#ifndef __KEYS_H__
#define __KEYS_H__

#include <kbd.h>
#include <asmtypes.h>

// change to _89 or _92plus to compile for both calcs
#define _92plus

#ifdef _89
#define Q89_92(x,y) (x)
#else
#define Q89_92(x,y) (y)
#endif

#define KEYNAME_LENGTH 16


const char* KeyMaskToStr(unsigned short row,
                         unsigned short column);

void GetKey(unsigned short *row,
            unsigned short *column);


#endif
