// C Source File
// Created 3/15/2002; 7:55:56 PM


#include "network.h"
#include <all.h>

unsigned short my_status = NO_CONNECTION;
unsigned short machine = NEITHER;
long timeout = RESET_TIMEOUT;

void networkPing()
{
	char buffer[2];

  // reset connection
  my_status = NO_CONNECTION;
  machine = NEITHER;

  // read (if the other calc pinged first) and send out my ping
  OSReadLinkBlock(buffer,1);
  buffer[0] = (char)(PING);
  OSWriteLinkBlock(buffer,1);
}

void networkListen()
{
	char buffer[2];

  if (machine == NEITHER)
  {
    OSReadLinkBlock(buffer,1);
    if (buffer[0] == PING)
    {
      // The other calc sent out a connecting message.
      buffer[0] = (char)(PONG);
      OSWriteLinkBlock(buffer,1);

      machine = SERVER;
      timeout = RESET_TIMEOUT;
    }
    else if (buffer[0] == PONG)
    {
      // The other calc got our connecting message and
      // sent back connected.
      buffer[0] = (char)(PUNG);
      OSWriteLinkBlock(buffer,1);

      machine = CLIENT;
      timeout = RESET_TIMEOUT;
    }
  }
  else if (timeout == 0)
  {
  	machine = NEITHER;
  }
  else if (machine == CLIENT)
  {
    OSReadLinkBlock(buffer,1);
    if (buffer[0] == PONG || buffer[0] == WAITING)
    {
      buffer[0] = (char)(PUNG);
      OSWriteLinkBlock(buffer,1);
      timeout = RESET_TIMEOUT;
    }
    else
    {
      timeout--;
    }
  }
  else if (machine == SERVER)
  {
    OSReadLinkBlock(buffer,1);
    if (buffer[0] == PUNG || buffer[0] == WAITING)
    {
      buffer[0] = (char)(PONG);
      OSWriteLinkBlock(buffer,1);
      timeout = RESET_TIMEOUT;
    }
    else
    {
      timeout--;
    }
  }
}


unsigned short getMachine()
{
  return machine;
}


BOOL networkReady()
{
  char buffer[2];
  BOOL rval = FALSE;

  if (timeout == 0)
  {
  	machine = NEITHER;
  	timeout = RESET_TIMEOUT;
  }
  else if (machine == CLIENT)
  {
    OSReadLinkBlock(buffer,1);
    if (buffer[0] == PONG)
    {
      buffer[0] = (char)(WAITING);
      OSWriteLinkBlock(buffer,1);
      timeout = RESET_TIMEOUT;
    }
    else if (buffer[0] == WAITING)
    {
      buffer[0] = (char)(PLAYING);
      OSWriteLinkBlock(buffer,1);
      timeout = RESET_TIMEOUT;
      rval = TRUE;
    }
    else if (buffer[0] == PLAYING)
    {
      rval = TRUE;
    }
    else
    {
      timeout--;
    }
  }
  else if (machine == SERVER)
  {
    OSReadLinkBlock(buffer,1);
    if (buffer[0] == PUNG)
    {
      buffer[0] = (char)(WAITING);
      OSWriteLinkBlock(buffer,1);
      timeout = RESET_TIMEOUT;
    }
    else if (buffer[0] == WAITING)
    {
      buffer[0] = (char)(PLAYING);
      OSWriteLinkBlock(buffer,1);
      timeout = RESET_TIMEOUT;
      rval = TRUE;
    }
    else if (buffer[0] == PLAYING)
    {
      rval = TRUE;
    }
    else
    {
      timeout--;
    }
  }

  return rval;
}

